#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

int (*old_runops) ( pTHX );
OP  *resume_op   = NULL;
OP  *post_resume = NULL;

int runops_resume(pTHX)
{
	OP * old_op;
	SV * blessed_op;
	int count = 1;

    while (PL_op)
	{

		if ( PL_op->op_type == OP_DIE && PL_in_eval )
			resume_op = PL_op;

		PL_op = CALL_FPTR( PL_op->op_ppaddr )( aTHX );
		PERL_ASYNC_CHECK();

		if (post_resume)
		{
			if (PL_op->op_type == OP_ENTERTRY)
			{
				count++;
			}
			else if (PL_op->op_type == OP_LEAVETRY)
			{
				count--;
			}

			if (count == 0)
			{
				PL_op       = post_resume;
				post_resume = NULL;
			}
		}
	}

	TAINT_NOT;
	return 0;
}

MODULE = Runops::Resume PACKAGE = Runops::Resume

BOOT:
	old_runops = PL_runops;
    PL_runops  = runops_resume;

void
resume ()
	CODE:
		if (resume_op != NULL)
		{
			post_resume = PL_op->op_next;
			PL_op       = resume_op;
		}
