#!/usr/bin/perl

use strict;
use warnings;

use Test::More tests => 5;

BEGIN { use_ok( 'Runops::Resume' ) };

# $flow tracks the control flow -- 'abcde'
my $flow = 'a';
my $text = 'before';
eval 
{
	is( $text, 'before', 'normal control flow should work' );
	$flow .= 'b';
	$text = 'after';
	die "Leaving with exception";
	is( $text, 'after', 'resume() should return to normal spot' );
	$flow .= 'd';
};

like( $@, qr/Leaving with exception/, 'eval() should exit as normal' );
$flow .= 'c';

resume();
$flow .= 'e';

is( $flow, 'abcde', '... leaving no ill effects' );
